%define gccversion 2.8.1
%define gccpath i386-redhat-linux
%define gnatlibver 3.12
%define gnatversion 3.12p
%define somajor 1
%define sominor 12

Summary: GNAT - shared libraries for GNU Ada95 compiler
Name: gnat
Version: 3.12p
Release: 6
Copyright: GPL
ExclusiveArch: i386 i486 i586 i686
Group: System Environment/Libraries
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-%{gccversion}.tar.gz
Source1: ftp://cs.nyu.edu:/pub/gnat/gnat-%version-src.tar.gz
Source2: ftp://cs.nyu.edu:/pub/gnat/gnat-%version-docs.tar.gz
Source3: gnat.1
Patch1: gcc281.patch
Patch2: gnat312p-docs.patch
Patch3: gnat312p.patch
Requires: glibc >= 2.1.2
BuildRoot: %{_tmppath}/%{name}-root
BuildPrereq: /sbin/ldconfig, gnat >= 3.12p, gnat-devel >= 3.12p
Prereq: /sbin/ldconfig
prefix: /usr

%description
GNAT is a GNU Ada95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.

%package devel
Summary: GNAT - GNU ada95 compiler, documents and development tools
Requires: binutils >= 2.9.1
Group: Development/Languages

%description devel
GNAT is a GNU Ada front-end to GCC. This package includes development tools,
the documents and Ada95 compiler.

%prep
%setup -q -n gcc-%{gccversion} -a 1 -a 2
%patch1 -p1
%patch2 -p0
%patch3 -p0

mv %{name}-%{version}-src/src/ada .
patch -p0 < %{name}-%{version}-src/src/gcc-281.dif

%build
test -f cstamp-h.in && touch cstamp-h.in
cd ada && touch treeprs.ads a-[es]info.h nmake.ad[bs] c-gperf.h

for f in osint.adb; do
  mv -f ${f} ${f}.in
  sed "s:@AINC_DIR@:%{AINC_DIR}:g" < ${f}.in |\
  sed "s:@ALIB_DIR@:%{ALIB_DIR}:g" > ${f}
  rm -f ${f}.in
done

cat > glibcvers.def <<EOF
GLIBC_20 := FALSE
GLIBC_21 := TRUE
EOF

rm -f 5iosinte.ads
gnatprep 5iosinte.ads_p 5iosinte.ads glibcvers.def
rm -f glibcvers.def
cd ..

export CC="gnatgcc -pipe"
export LIBGCC=libgnatgcc.a
./configure --prefix=/usr %gccpath

make CFLAGS="$RPM_OPT_FLAGS" \
	GNATLIBCFLAGS="-gnatpn -UIN_GCC" \
	ADAFLAGS="-gnatpn -gnatg" \
	GNATLIBFLAGS="-gnatpn -gnatg" \
	LIBGCC="libgnatgcc.a" \
	SO_MAJOR="%{somajor}" \
	SO_MINOR="%{sominor}" \
	SO_BASE="%{gnatversion}" \
	MAKEINFO="makeinfo --no-split" \
	LANGUAGES="c ada"

make CFLAGS="$RPM_OPT_FLAGS" \
	GNATLIBCFLAGS="-gnatpn -UIN_GCC" \
	ADAFLAGS="-gnatpn -gnatg" \
	GNATLIBFLAGS="-gnatpn -gnatg" \
	LIBGCC="libgnatgcc.a" \
	SO_MAJOR="%{somajor}" \
	SO_MINOR="%{sominor}" \
	SO_BASE="%{gnatversion}" \
	LANGUAGES="c ada" gnattools

make CFLAGS="$RPM_OPT_FLAGS" \
        GNATLIBCFLAGS="-gnatpn -UIN_GCC" \
        ADAFLAGS="-gnatpn -gnatg" \
        GNATLIBFLAGS="-gnatpn -gnatg" \
        LIBGCC="libgnatgcc.a" \
        SO_MAJOR="%{somajor}" \
        SO_MINOR="%{sominor}" \
        SO_BASE="%{gnatversion}" \
	LANGUAGES="c ada" gnatlib

mkdir -p ada/rts-build
cp -f ada/rts/*.a ada/rts-build
rm -f ada/rts/{*.o,*.ali,*.a} stamp-gnatlib*

# shared
make CFLAGS="$RPM_OPT_FLAGS" \
        GNATLIBCFLAGS="-gnatpn -UIN_GCC" \
        ADAFLAGS="-gnatpn -gnatg -I-" \
        GNATLIBFLAGS="-gnatpn -gnatg" \
        LIBGCC="libgnatgcc.a" \
        SO_MAJOR="%{somajor}" \
        SO_MINOR="%{sominor}" \
        SO_BASE="%{gnatversion}" \
        LANGUAGES="c ada" gnatlib-shared

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/{info,share/man}

make install prefix=$RPM_BUILD_ROOT%{prefix} \
	MAKEINFO="makeinfo --no-split" \
	LIBGCC=libgnatgcc.a INSTALL_LIBGCC=install-alt-libgcc \
	LANGUAGES="c ada" \
	mandir=$RPM_BUILD_ROOT%{prefix}/share/man/man1 \
	GCC_INSTALL_NAME=gnatgcc

# remove something, we dont need
rm -f $RPM_BUILD_ROOT%{prefix}/bin/%{gccpath}-gcc
rm -rf $RPM_BUILD_ROOT%{prefix}/info

# move the shared libraries in /usr/lib
mv $RPM_BUILD_ROOT%{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}/adalib/libgnarl.so \
	$RPM_BUILD_ROOT%{prefix}/lib/libgnarl-%{gnatversion}.so.%{somajor}.%{sominor}
mv $RPM_BUILD_ROOT%{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}/adalib/libgnat.so \
	$RPM_BUILD_ROOT%{prefix}/lib/libgnat-%{gnatversion}.so.%{somajor}.%{sominor}

# make links to the shared libraries
/sbin/ldconfig -n $RPM_BUILD_ROOT%{prefix}/lib
ln -fs ../../../../libgnarl-%{gnatversion}.so.%{somajor}.%{sominor} \
	$RPM_BUILD_ROOT%{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}/adalib/libgnarl.so
ln -fs ../../../../libgnat-%{gnatversion}.so.%{somajor}.%{sominor} \
	$RPM_BUILD_ROOT%{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}/adalib/libgnat.so

cd $RPM_BUILD_ROOT%{prefix}/lib
ln -fs libgnarl-%{gnatversion}.so.%{somajor} libgnarl-%{gnatversion}.so
ln -fs libgnat-%{gnatversion}.so.%{somajor} libgnat-%{gnatversion}.so

# install gnat man page
install -m 0444 %{SOURCE3} $RPM_BUILD_ROOT%{prefix}/share/man/man1

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%{prefix}/lib/*.so.1*

%files devel
%defattr(-, root, root)
%doc gnat-%{gnatversion}-docs/*.html
%doc gnat-%{gnatversion}-src/examples
%dir %{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}
%{prefix}/bin/*
%{prefix}/lib/*.so
%{prefix}/lib/gcc-lib/%{gccpath}/%{gccversion}/*
%{_mandir}/man1/gnat.1*

%changelog
* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Mon Jul 24 2000 Than Ngo <than@redhat.de>
- add BuildPrereq

* Wed Jul 12 2000 Than Ngo <than@redhat.de>
- rebuilt
- use RPM macros

* Mon Jul 03 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Wed May 24 2000 Ngo Than <than@redhat.de>
- add %clean

* Mon May 22 2000 Ngo Than <than@redhat.de>
- initial RPM for 7.0
